package memento;

public class CarModel {
    private float height;
    private float width;
    private float cargoVolume;
    private float wheelbase;

    //método que restaura o estado de CarModel a partir de um Snapshot
    public void restoreCarModel(CarModelSnapshot cp){
        this.height = cp.getHeight();
        this.width = cp.getWidth();
        this.cargoVolume = cp.getCargoVolume();
        this.wheelbase = cp.getWheelbase();
    }

    //Armazena os atributos atuais de CarModel em uma classe CarModelSnapshot,
    //armazenando seu estado.
    public CarModelSnapshot createSnapshot(){
        return new CarModelSnapshot(
                this.height,
                this.width,
                this.cargoVolume,
                this.wheelbase
        );
    }

    public String getCarInfo(){
        return "Height: " + this.height +
                "\nWidth: " + this.width +
                "\nCargo volume: " + this.cargoVolume +
                "\nWheelbase: " + this.wheelbase;
    }

    public float getHeight() {
        return height;
    }

    public void setHeight(float height) {
        this.height = height;
    }

    public float getWidth() {
        return width;
    }

    public void setWidth(float width) {
        this.width = width;
    }

    public float getCargoVolume() {
        return cargoVolume;
    }

    public void setCargoVolume(float cargoVolume) {
        this.cargoVolume = cargoVolume;
    }

    public float getWheelbase() {
        return wheelbase;
    }

    public void setWheelbase(float wheelbase) {
        this.wheelbase = wheelbase;
    }
}