package memento;

public class CarModelChecker {

    private CarModel carModel;
    private CarModelSnapshot carModelSnapshot;

    public CarModelChecker(CarModel carModel){
        this.carModel = carModel;
    }

    public CarModelSnapshot getCarModelSnapshot() {
        return carModelSnapshot;
    }

    public void setCarModelSnapshot(CarModelSnapshot carModelSnapshot) {
        this.carModelSnapshot = carModelSnapshot;
    }

    public CarModel getCarModel() {
        return carModel;
    }

    //método chamado quando os atributos de CarModel precisam ser modificados.
    public void doAdjustments(float heightAdd, float widthAdd,
                              float cargoVolumeAdd, float wheelbaseAdd){
        //A partir de CarModel, um snapshot com seu estado é criado
        //e armazenado em CarModelChecker.
        this.carModelSnapshot = carModel.createSnapshot();

        carModel.setHeight(carModel.getHeight() + heightAdd);
        carModel.setWidth(carModel.getWidth() + widthAdd);
        carModel.setCargoVolume(carModel.getCargoVolume() + cargoVolumeAdd);
        carModel.setWheelbase(carModel.getWheelbase() + wheelbaseAdd);
    }

    //Restaura o estado de CarModel para o do snapshot salvo
    public void undoAdjustments(){
        this.carModel.restoreCarModel(this.carModelSnapshot);
    }

}