package memento;

public class Client {

    public static void main(String[] args) {
        CarModel carModel = new CarModel();

        //Um modelo de carro é criado e seus atributos são definidos
        carModel.setHeight(1.4f);
        carModel.setWidth(1.8f);
        carModel.setCargoVolume(1.3f);
        carModel.setWheelbase(3.9f);

        //Uma instância de CarModelChecker armazena o CarModel criado
        CarModelChecker modelChecker = new CarModelChecker(carModel);

        System.out.println("Model before adjustments: \n" + modelChecker.getCarModel().getCarInfo() + "\n\n");

        //O método doAdjustments é chamado para alterar os valores do carro dentro de CarModelChecker.
        modelChecker.doAdjustments(0.4f, -0.6f, 1, -1.8f);

        System.out.println("Car after adjustments: \n" + modelChecker.getCarModel().getCarInfo() + "\n\n");

        //Um teste é realizado e se o mesmo falhar, significa que o modelo deve retornar ao
        //seu estado anterior, salvo em CarModelChecker
        if(!testModel(modelChecker.getCarModel())){
            modelChecker.undoAdjustments(); //método que retorna carModel ao estado salvo em CarModelSnapshot

            System.out.println("Car after test failure: \n" + modelChecker.getCarModel().getCarInfo() + "\n\n");
        }
    }

    //método que realiza um teste em CarModel para validar seus atributos.
    public static boolean testModel(CarModel carModel){
        float value = (carModel.getWheelbase()/carModel.getHeight())
                      * carModel.getWidth();

        return value < 2*carModel.getWheelbase()
                && value > 2.5*carModel.getCargoVolume();
    }
}